namespace ProjectTank.Entities
{
    public class EntityTank
    {
         
        /// <summary>
         /// Скорость
         /// </summary>
        public int Speed { get; private set; }

        /// <summary>
        /// Вес
        /// </summary>
        public double Weight { get; private set; }

        /// <summary>
        /// Основной цвет
        /// </summary>
        public Color BodyColor { get; private set; }

        /// <summary>
        /// Шаг перемещения танка
        /// </summary>
        public double Step => Speed * 100 / Weight;
        public void SetBodyColor(Color color)
        {
            BodyColor = color;
        }

        /// <summary>
        /// Конструктор сущности
        /// </summary>
        /// <param name="speed">Скорость</param>
        /// <param name="weight">Веc</param>
        /// <param name="bodyColor">Основной цвет</param>

        public EntityTank(int speed, double weight, Color bodyColor)
        {
            Speed = speed;
            Weight = weight;
            BodyColor = bodyColor;

        }
        public virtual string[] GetStringRepresentation()
        {
            return new[] { nameof(EntityTank), Speed.ToString(), Weight.ToString(), BodyColor.Name };
        }

        /// <summary>
        /// Создание объекта из массива строк
        /// </summary>
        /// <param name="strs"></param>
        /// <returns></returns>
        public static EntityTank? CreateEntityTank(string[] strs)
        {
            if (strs.Length != 4 || strs[0] != nameof(EntityTank))
            {
                return null;
            }

            return new EntityTank(Convert.ToInt32(strs[1]), Convert.ToDouble(strs[2]), Color.FromName(strs[3]));
        }
    }
}
